searchData={"items":[{"type":"module","title":"BotEx.Application","doc":"","ref":"BotEx.Application.html"},{"type":"function","title":"BotEx.Application.start/2","doc":"","ref":"BotEx.Application.html#start/2"},{"type":"behaviour","title":"BotEx.Behaviours.BufferingStrategy","doc":"The behaviour for a module that implements a message buffering strategy","ref":"BotEx.Behaviours.BufferingStrategy.html"},{"type":"callback","title":"BotEx.Behaviours.BufferingStrategy.create_buffers/1","doc":"This function calling on start `BotEx.Routing.MessageHandler`\nand must return struct for saving incoming messages","ref":"BotEx.Behaviours.BufferingStrategy.html#c:create_buffers/1"},{"type":"callback","title":"Parameters - BotEx.Behaviours.BufferingStrategy.create_buffers/1","doc":"- handlers: handlers map as in config parameter handlers\nreturn buffer struct","ref":"BotEx.Behaviours.BufferingStrategy.html#c:create_buffers/1-parameters"},{"type":"callback","title":"BotEx.Behaviours.BufferingStrategy.get_messages/2","doc":"Return messages for send from buffer","ref":"BotEx.Behaviours.BufferingStrategy.html#c:get_messages/2"},{"type":"callback","title":"Parameters: - BotEx.Behaviours.BufferingStrategy.get_messages/2","doc":"- buffer: current buffer\n- key: any key for getting messages from buffer\n\nreturn list of messages for sending","ref":"BotEx.Behaviours.BufferingStrategy.html#c:get_messages/2-parameters"},{"type":"callback","title":"BotEx.Behaviours.BufferingStrategy.reset_buffer/2","doc":"Reset buffer values by key","ref":"BotEx.Behaviours.BufferingStrategy.html#c:reset_buffer/2"},{"type":"callback","title":"Parameters: - BotEx.Behaviours.BufferingStrategy.reset_buffer/2","doc":"- buffer: current buffer\n- key: any key for delete messages from buffer","ref":"BotEx.Behaviours.BufferingStrategy.html#c:reset_buffer/2-parameters"},{"type":"callback","title":"BotEx.Behaviours.BufferingStrategy.schedule_buffer_flush/3","doc":"This function call on one buffer flushing\nfor  planning next buffer flush. Must send `{:flush_buffer, bot, handler}` message to `handler_pid`","ref":"BotEx.Behaviours.BufferingStrategy.html#c:schedule_buffer_flush/3"},{"type":"callback","title":"Parameters: - BotEx.Behaviours.BufferingStrategy.schedule_buffer_flush/3","doc":"- key: any key for get value from buffer\n- buffering_time: buffering time\n- handler_pid: pid of `BotEx.Routing.MessageHandler`\n\nreturn reference from `Process.send_after`","ref":"BotEx.Behaviours.BufferingStrategy.html#c:schedule_buffer_flush/3-parameters"},{"type":"callback","title":"BotEx.Behaviours.BufferingStrategy.schedule_flush_all/3","doc":"This function calling on start `BotEx.Routing.MessageHandler`\nand create a plan for flush all buffers from `create_buffers`","ref":"BotEx.Behaviours.BufferingStrategy.html#c:schedule_flush_all/3"},{"type":"callback","title":"Parameters: - BotEx.Behaviours.BufferingStrategy.schedule_flush_all/3","doc":"- handlers: map of handlers as in config\n- default_buffering_time: default buffering time from config, can be replaced for the handler\n- handler_pid: pid of `BotEx.Routing.MessageHandler`\n\nreturn handlers map","ref":"BotEx.Behaviours.BufferingStrategy.html#c:schedule_flush_all/3-parameters"},{"type":"callback","title":"BotEx.Behaviours.BufferingStrategy.update_buffers_from_messages/2","doc":"This function calling on receive new messages and must\nput it on them a place in buffer struct from `create_buffers`","ref":"BotEx.Behaviours.BufferingStrategy.html#c:update_buffers_from_messages/2"},{"type":"callback","title":"Parameters - BotEx.Behaviours.BufferingStrategy.update_buffers_from_messages/2","doc":"- msg_list: list of new messages\n- current_buffer: buffer with messages\n\nreturn new buffer with added messages","ref":"BotEx.Behaviours.BufferingStrategy.html#c:update_buffers_from_messages/2-parameters"},{"type":"behaviour","title":"BotEx.Behaviours.GroupingStrategy","doc":"The behaviour for a module that implements a message buffering strategy","ref":"BotEx.Behaviours.GroupingStrategy.html"},{"type":"callback","title":"BotEx.Behaviours.GroupingStrategy.group_and_send/1","doc":"This function uses `BotEx.Routing.Router` for grouping messages by some parameters","ref":"BotEx.Behaviours.GroupingStrategy.html#c:group_and_send/1"},{"type":"behaviour","title":"BotEx.Behaviours.Handler","doc":"Basic behaviour for the Handler module","ref":"BotEx.Behaviours.Handler.html"},{"type":"callback","title":"BotEx.Behaviours.Handler.get_cmd_name/0","doc":"Returns a command is responsible for module processing","ref":"BotEx.Behaviours.Handler.html#c:get_cmd_name/0"},{"type":"callback","title":"BotEx.Behaviours.Handler.handle_message/1","doc":"Message handler","ref":"BotEx.Behaviours.Handler.html#c:handle_message/1"},{"type":"callback","title":"Parameters - BotEx.Behaviours.Handler.handle_message/1","doc":"- msg: incoming `BotEx.Models.Message` message.\r\n- state: current state\r\nreturn new state","ref":"BotEx.Behaviours.Handler.html#c:handle_message/1-parameters"},{"type":"behaviour","title":"BotEx.Behaviours.Hook","doc":"Basic behaviour for the Hook module","ref":"BotEx.Behaviours.Hook.html"},{"type":"callback","title":"BotEx.Behaviours.Hook.run/0","doc":"Does something at a certain moment","ref":"BotEx.Behaviours.Hook.html#c:run/0"},{"type":"behaviour","title":"BotEx.Behaviours.Middleware","doc":"Behaviour for a module that changes the contents of `BotEx.Models.Message`","ref":"BotEx.Behaviours.Middleware.html"},{"type":"callback","title":"BotEx.Behaviours.Middleware.transform/1","doc":"Changes the contents of `BotEx.Models.Message`","ref":"BotEx.Behaviours.Middleware.html#c:transform/1"},{"type":"callback","title":"Parameters - BotEx.Behaviours.Middleware.transform/1","doc":"- msg: `BotEx.Models.Message` from `MiddlewareParser` or other `Middleware`","ref":"BotEx.Behaviours.Middleware.html#c:transform/1-parameters"},{"type":"behaviour","title":"BotEx.Behaviours.MiddlewareParser","doc":"The behaviour for the inbox transformation module","ref":"BotEx.Behaviours.MiddlewareParser.html"},{"type":"callback","title":"BotEx.Behaviours.MiddlewareParser.transform/1","doc":"Transforms the original message into `BotEx.Models.Message`","ref":"BotEx.Behaviours.MiddlewareParser.html#c:transform/1"},{"type":"callback","title":"Parameters - BotEx.Behaviours.MiddlewareParser.transform/1","doc":"- msg: any message from outer service","ref":"BotEx.Behaviours.MiddlewareParser.html#c:transform/1-parameters"},{"type":"module","title":"BotEx.Config","doc":"Configurations module\n\n# Example:\n```elixir\nconfig :bot_ex,\n  middleware: [\n    my_bot: [\n      MyBot.Middleware.MessageTransformer,\n      MyBot.Middleware.Auth\n    ]\n  ],\n  handlers: [\n    my_bot: [\n      {MyBot.Handlers.Start, 1000} # {module, bufering time}\n    ]\n  ],\n  bots: [:my_bot]\n```","ref":"BotEx.Config.html"},{"type":"function","title":"BotEx.Config.get/2","doc":"Return config value by name","ref":"BotEx.Config.html#get/2"},{"type":"function","title":"BotEx.Config.init/0","doc":"","ref":"BotEx.Config.html#init/0"},{"type":"function","title":"BotEx.Config.put/2","doc":"","ref":"BotEx.Config.html#put/2"},{"type":"module","title":"BotEx.Core.Messages.DefaultBufferingStrategy","doc":"This module buffering messages for each handler of bot","ref":"BotEx.Core.Messages.DefaultBufferingStrategy.html"},{"type":"function","title":"BotEx.Core.Messages.DefaultBufferingStrategy.schedule_buffer_flush/4","doc":"","ref":"BotEx.Core.Messages.DefaultBufferingStrategy.html#schedule_buffer_flush/4"},{"type":"module","title":"BotEx.Core.Messages.DefaultGroupingStrategy","doc":"Module grouping messages by fields: user, module and bot","ref":"BotEx.Core.Messages.DefaultGroupingStrategy.html"},{"type":"module","title":"BotEx.Core.Middleware","doc":"","ref":"BotEx.Core.Middleware.html"},{"type":"function","title":"BotEx.Core.Middleware.apply_to_messages/2","doc":"","ref":"BotEx.Core.Middleware.html#apply_to_messages/2"},{"type":"function","title":"BotEx.Core.Middleware.call_middleware/2","doc":"","ref":"BotEx.Core.Middleware.html#call_middleware/2"},{"type":"function","title":"BotEx.Core.Middleware.check_middleware!/1","doc":"","ref":"BotEx.Core.Middleware.html#check_middleware!/1"},{"type":"module","title":"BotEx.Handlers.ModuleHandler","doc":"The base macro that all message handlers should implement","ref":"BotEx.Handlers.ModuleHandler.html"},{"type":"module","title":"BotEx.Handlers.ModuleInit","doc":"A simple macro to initialize a GenServer.\nTakes the current state structure as an argument\nExample\n```elixir\nuse BotEx.Handlers.ModuleInit, state: [menu: []]\n```","ref":"BotEx.Handlers.ModuleInit.html"},{"type":"module","title":"BotEx.Helpers.Debug","doc":"","ref":"BotEx.Helpers.Debug.html"},{"type":"function","title":"BotEx.Helpers.Debug.print_debug/1","doc":"Print debug message if it enabled in config","ref":"BotEx.Helpers.Debug.html#print_debug/1"},{"type":"module","title":"BotEx.Helpers.Tools","doc":"Secondary functions","ref":"BotEx.Helpers.Tools.html"},{"type":"function","title":"BotEx.Helpers.Tools.check_behaviours!/2","doc":"","ref":"BotEx.Helpers.Tools.html#check_behaviours!/2"},{"type":"function","title":"BotEx.Helpers.Tools.check_path!/1","doc":"Checked if the file exists at the given path","ref":"BotEx.Helpers.Tools.html#check_path!/1"},{"type":"function","title":"Parameters - BotEx.Helpers.Tools.check_path!/1","doc":"- path: file path in any valid format for `File.exists?/1`","ref":"BotEx.Helpers.Tools.html#check_path!/1-parameters"},{"type":"function","title":"BotEx.Helpers.Tools.is_behaviours?/2","doc":"Checks the behavior is implemented by module","ref":"BotEx.Helpers.Tools.html#is_behaviours?/2"},{"type":"function","title":"Parameters - BotEx.Helpers.Tools.is_behaviours?/2","doc":"- module: module for checking\n- behaviour: behaviour for checking","ref":"BotEx.Helpers.Tools.html#is_behaviours?/2-parameters"},{"type":"module","title":"BotEx.Helpers.UserActions","doc":"User actions interacting functions","ref":"BotEx.Helpers.UserActions.html"},{"type":"function","title":"BotEx.Helpers.UserActions.get_last_call/1","doc":"Find the last user action","ref":"BotEx.Helpers.UserActions.html#get_last_call/1"},{"type":"function","title":"Parameters: - BotEx.Helpers.UserActions.get_last_call/1","doc":"- u_id: user id","ref":"BotEx.Helpers.UserActions.html#get_last_call/1-parameters"},{"type":"function","title":"BotEx.Helpers.UserActions.update_last_call/2","doc":"Update last user message","ref":"BotEx.Helpers.UserActions.html#update_last_call/2"},{"type":"function","title":"Parameters: - BotEx.Helpers.UserActions.update_last_call/2","doc":"- user_id: user id\n- call: `BotEx.Models.Message` for saving","ref":"BotEx.Helpers.UserActions.html#update_last_call/2-parameters"},{"type":"module","title":"BotEx.Middleware.LastCallUpdater","doc":"Refresh last calls table","ref":"BotEx.Middleware.LastCallUpdater.html"},{"type":"function","title":"BotEx.Middleware.LastCallUpdater.transform/1","doc":"Save last user message to ets table","ref":"BotEx.Middleware.LastCallUpdater.html#transform/1"},{"type":"module","title":"BotEx.Middleware.MessageLogger","doc":"Logs messages","ref":"BotEx.Middleware.MessageLogger.html"},{"type":"function","title":"BotEx.Middleware.MessageLogger.info_to_string/1","doc":"Create debug message from `BotEx.Models.Message`","ref":"BotEx.Middleware.MessageLogger.html#info_to_string/1"},{"type":"function","title":"BotEx.Middleware.MessageLogger.transform/1","doc":"Debug messages in terminal","ref":"BotEx.Middleware.MessageLogger.html#transform/1"},{"type":"module","title":"BotEx.Models.Button","doc":"","ref":"BotEx.Models.Button.html"},{"type":"type","title":"BotEx.Models.Button.t/0","doc":"Module, that represents menu button struct.","ref":"BotEx.Models.Button.html#t:t/0"},{"type":"type","title":"Fields: - BotEx.Models.Button.t/0","doc":"- `text`: visible text,\n- `module`: call module,\n- `action`: action,\n- `data`: some data","ref":"BotEx.Models.Button.html#t:t/0-fields"},{"type":"module","title":"BotEx.Models.Menu","doc":"","ref":"BotEx.Models.Menu.html"},{"type":"type","title":"BotEx.Models.Menu.t/0","doc":"Module, that represents menu struct.","ref":"BotEx.Models.Menu.html#t:t/0"},{"type":"type","title":"Fields: - BotEx.Models.Menu.t/0","doc":"- `name`: menu unique identifier,\n- `text`: menu text,\n- `buttons`: list of buttons `BotEx.Models.Button`  or a function that returns list of buttons\n- `custom`: any data","ref":"BotEx.Models.Menu.html#t:t/0-fields"},{"type":"module","title":"BotEx.Models.Message","doc":"","ref":"BotEx.Models.Message.html"},{"type":"type","title":"BotEx.Models.Message.t/0","doc":"Module, that represents message wrapper struct\n\n##\n- `is_cmd`: is it a command or not,\n- `module`: the name of the module that will be called must match the result of `BotEx.Handlers.ModuleHandler.get_cmd_name/0`,\n- `action`: action,\n- `data`: data,\n- `msg`: original message\n- `user`: current user\n- `user_id`: user id\n- `text`: message text, if any\n- `force_new`:- report that editing the message is undesirable\n- `chat_id`:- chat id\n- `custom_data`:- any additional data","ref":"BotEx.Models.Message.html#t:t/0"},{"type":"module","title":"BotEx.Routing.MessageHandler","doc":"","ref":"BotEx.Routing.MessageHandler.html"},{"type":"function","title":"BotEx.Routing.MessageHandler.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BotEx.Routing.MessageHandler.html#child_spec/1"},{"type":"function","title":"BotEx.Routing.MessageHandler.get_config/0","doc":"Return current module config\n[middleware: middleware, default_buffering_time: time, buffering_strategy: buffering_strategy]","ref":"BotEx.Routing.MessageHandler.html#get_config/0"},{"type":"function","title":"BotEx.Routing.MessageHandler.handle/2","doc":"Apply middleware modules to messages","ref":"BotEx.Routing.MessageHandler.html#handle/2"},{"type":"function","title":"BotEx.Routing.MessageHandler.handle_cast/2","doc":"Apply middleware to incoming messages and buffering them","ref":"BotEx.Routing.MessageHandler.html#handle_cast/2"},{"type":"function","title":"Parameters - BotEx.Routing.MessageHandler.handle_cast/2","doc":"- {bot_key, msg_list}: bot_key - atom with bot key,\nlist - list incoming `BotEx.Models.Message` messages\n- state: current state","ref":"BotEx.Routing.MessageHandler.html#handle_cast/2-parameters"},{"type":"function","title":"BotEx.Routing.MessageHandler.handle_info/2","doc":"Fluhs messages to handlers","ref":"BotEx.Routing.MessageHandler.html#handle_info/2"},{"type":"function","title":"BotEx.Routing.MessageHandler.init/1","doc":"","ref":"BotEx.Routing.MessageHandler.html#init/1"},{"type":"function","title":"BotEx.Routing.MessageHandler.reload_config/0","doc":"Reload config from storage","ref":"BotEx.Routing.MessageHandler.html#reload_config/0"},{"type":"function","title":"BotEx.Routing.MessageHandler.start_link/1","doc":"","ref":"BotEx.Routing.MessageHandler.html#start_link/1"},{"type":"function","title":"BotEx.Routing.MessageHandler.update_config/1","doc":"Update config.","ref":"BotEx.Routing.MessageHandler.html#update_config/1"},{"type":"function","title":"Parameters - BotEx.Routing.MessageHandler.update_config/1","doc":"- config: list of new middleware, default_buffering_time, buffering_strategy.\n[middleware: [`Middleware`, ...], default_buffering_time: 2000, buffering_strategy: `BufferingStrategy`]","ref":"BotEx.Routing.MessageHandler.html#update_config/1-parameters"},{"type":"module","title":"BotEx.Routing.MessageHandler.State","doc":"","ref":"BotEx.Routing.MessageHandler.State.html"},{"type":"type","title":"BotEx.Routing.MessageHandler.State.t/0","doc":"State for `BotEx.Routing.MessageHandler`","ref":"BotEx.Routing.MessageHandler.State.html#t:t/0"},{"type":"type","title":"Fields: - BotEx.Routing.MessageHandler.State.t/0","doc":"- `middleware`: list all possible middleware\n- `message_buffer`: buffering messages\n- `default_buffering_time`: time buffering messages\n- `buffering_strategy`: strategy for buffering messages. Must implements `BotEx.Behaviours.BufferingStrategy`","ref":"BotEx.Routing.MessageHandler.State.html#t:t/0-fields"},{"type":"module","title":"BotEx.Routing.Router","doc":"","ref":"BotEx.Routing.Router.html"},{"type":"function","title":"BotEx.Routing.Router.handle_msgs/3","doc":"","ref":"BotEx.Routing.Router.html#handle_msgs/3"},{"type":"function","title":"BotEx.Routing.Router.send_to_handler/1","doc":"Send messages to handlers.","ref":"BotEx.Routing.Router.html#send_to_handler/1"},{"type":"function","title":"Parameters: - BotEx.Routing.Router.send_to_handler/1","doc":"- msgs: list of `BotEx.Models.Message`","ref":"BotEx.Routing.Router.html#send_to_handler/1-parameters"},{"type":"module","title":"BotEx.Services.Analytics.ChatBase","doc":"Analytics Gathering Module","ref":"BotEx.Services.Analytics.ChatBase.html"},{"type":"function","title":"BotEx.Services.Analytics.ChatBase.send_data/4","doc":"Sends information to analytics collection service\nmore details about the parameters can be found\nin [documentation](https://chatbase.com/documentation/docs-overview)","ref":"BotEx.Services.Analytics.ChatBase.html#send_data/4"},{"type":"function","title":"Parameters - BotEx.Services.Analytics.ChatBase.send_data/4","doc":"- msg: message\n- user_id: user id\n- intent: intent\n- platform: platform","ref":"BotEx.Services.Analytics.ChatBase.html#send_data/4-parameters"},{"type":"exception","title":"BotEx.Exceptions.BehaviourError","doc":"","ref":"BotEx.Exceptions.BehaviourError.html"},{"type":"exception","title":"BotEx.Exceptions.ConfigError","doc":"","ref":"BotEx.Exceptions.ConfigError.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}